#include <Time.h>
#include <Wire.h>
#include <DS1307RTC.h>

#include "config.h"
#include "wordclock_ch.h"


int ledMatrix[12];
int newMatrix[12] = {0,0,0,0,0,0,0,0,0,0,0,0};
int lineNumber = 0;
tmElements_t oldTime;

void setup() {
  pinMode(10, OUTPUT);
  pinMode(11, OUTPUT);
  pinMode(ANODEPIN1, OUTPUT);
  pinMode(ANODEPIN2, OUTPUT);
  pinMode(ANODEPIN3, OUTPUT);
  pinMode(ANODEPIN4, OUTPUT);
  pinMode(ANODEPIN5, OUTPUT);
  pinMode(ANODEPIN6, OUTPUT);
  pinMode(ANODEPIN7, OUTPUT);
  pinMode(ANODEPIN8, OUTPUT);
  pinMode(ANODEPIN9, OUTPUT);
  pinMode(ANODEPIN10, OUTPUT);
  pinMode(ANODEPIN11, OUTPUT);
  pinMode(ANODEPIN12, OUTPUT);
  Serial.begin(9600);
  delay(5000);
  

}

void loop() {

  tmElements_t time;

  if (RTC.read(time)) {
    if (time.Minute != oldTime.Minute) {
      Serial.print("Hour:");
      Serial.print(time.Hour);
      Serial.print("     Minute:");
      Serial.print(time.Minute);
      Serial.print("     Second:");
      Serial.println(time.Second);
      for(int i = 0; i < 12; i++) {
        newMatrix[i] = 0; 
      }
      int minutes = time.Minute;
      int hoursTwentyfour = time.Hour;
      int oldMatrix[12];
      //memcpy(oldMatrix, ledMatrix, 12);
      LANGUAGECODE


        for(int y = 0; y < 14; y++) {

        for(int i = 0; i < 12; i++) {
          ledMatrix[i] = ledMatrix[i] | ((newMatrix[i] << (14-y)) & 0x4000);
          ledMatrix[i] = ledMatrix[i] >> 1;
        }

        for(int x = 0; x < 4; x++) {

          digitalWrite(11, HIGH);
          digitalWrite(10, HIGH);
          delayMicroseconds(10);
          digitalWrite(10, LOW);
          digitalWrite(11, LOW);

          digitalWrite(2, ledMatrix[0] & 0x0001);
          digitalWrite(3, ledMatrix[0] & 0x0002);
          digitalWrite(4, ledMatrix[0] & 0x0004);
          digitalWrite(5, ledMatrix[0] & 0x0008);
          digitalWrite(6, ledMatrix[0] & 0x0010);
          digitalWrite(7, ledMatrix[0] & 0x0020);
          digitalWrite(8, ledMatrix[0] & 0x0040);
          digitalWrite(9, ledMatrix[0] & 0x0080);
          digitalWrite(A0, (ledMatrix[0] & 0x0100) >> 1);
          digitalWrite(A1, (ledMatrix[0] & 0x0200) >> 2);
          digitalWrite(A3, (ledMatrix[0] & 0x0400) >> 3);
          digitalWrite(A2, (ledMatrix[0] & 0x0800) >> 4);

          delay(1);

          digitalWrite(2, LOW);
          digitalWrite(3, LOW);
          digitalWrite(4, LOW);
          digitalWrite(5, LOW);
          digitalWrite(6, LOW);
          digitalWrite(7, LOW);
          digitalWrite(8, LOW);
          digitalWrite(9, LOW);
          digitalWrite(A0, LOW);
          digitalWrite(A1, LOW);
          digitalWrite(A2, LOW);
          digitalWrite(A3, LOW);


          for(int i = 1; i < 12; i++) {

            digitalWrite(10, HIGH);
            delayMicroseconds(10);
            digitalWrite(10, LOW);

            digitalWrite(2, ledMatrix[i] & 0x0001);
            digitalWrite(3, ledMatrix[i] & 0x0002);
            digitalWrite(4, ledMatrix[i] & 0x0004);
            digitalWrite(5, ledMatrix[i] & 0x0008);
            digitalWrite(6, ledMatrix[i] & 0x0010);
            digitalWrite(7, ledMatrix[i] & 0x0020);
            digitalWrite(8, ledMatrix[i] & 0x0040);
            digitalWrite(9, ledMatrix[i] & 0x0080);
            digitalWrite(A0, (ledMatrix[i] & 0x0100) >> 1);
            digitalWrite(A1, (ledMatrix[i] & 0x0200) >> 2);
            digitalWrite(A3, (ledMatrix[i] & 0x0400) >> 3);
            digitalWrite(A2, (ledMatrix[i] & 0x0800) >> 4);

            delay(1);

            digitalWrite(2, LOW);
            digitalWrite(3, LOW);
            digitalWrite(4, LOW);
            digitalWrite(5, LOW);
            digitalWrite(6, LOW);
            digitalWrite(7, LOW);
            digitalWrite(8, LOW);
            digitalWrite(9, LOW);
            digitalWrite(A0, LOW);
            digitalWrite(A1, LOW);
            digitalWrite(A2, LOW);
            digitalWrite(A3, LOW);

          }
        }
      }
    }
    oldTime = time;
  }
  else{
    Serial.println("error"); 
  }

  for(int y = 0; y < CLOCKRATE; y++) {

    digitalWrite(11, HIGH);
    digitalWrite(10, HIGH);
    delayMicroseconds(10);
    digitalWrite(10, LOW);
    digitalWrite(11, LOW);

    displayMatrix(0);

    for(int i = 1; i < 12; i++) {

      digitalWrite(10, HIGH);
      delayMicroseconds(10);
      digitalWrite(10, LOW);

      displayMatrix(i);

    }

  }




}

void addWordToMatrix(int led) {
  int line = (led & 0xF000) >> 12;
  /*Serial.print("Line number: ");
   Serial.print(line);
   Serial.print(" Word: ");
   Serial.print(String(led, BIN));
   Serial.print(" Line: ");
   Serial.print(String(ledMatrix[line], BIN));*/
  MATRIXARRAY[line] = MATRIXARRAY[line] | (led & 0x0FFF);
  /*Serial.print(" New Line: ");
   Serial.println(String(ledMatrix[line], BIN));*/

}


void displayMatrix(int lineNumber) {


  digitalWrite(2, ledMatrix[lineNumber] & 0x0001);
  digitalWrite(3, ledMatrix[lineNumber] & 0x0002);
  digitalWrite(4, ledMatrix[lineNumber] & 0x0004);
  digitalWrite(5, ledMatrix[lineNumber] & 0x0008);
  digitalWrite(6, ledMatrix[lineNumber] & 0x0010);
  digitalWrite(7, ledMatrix[lineNumber] & 0x0020);
  digitalWrite(8, ledMatrix[lineNumber] & 0x0040);
  digitalWrite(9, ledMatrix[lineNumber] & 0x0080);
  digitalWrite(A0, (ledMatrix[lineNumber] & 0x0100) >> 1);
  digitalWrite(A1, (ledMatrix[lineNumber] & 0x0200) >> 2);
  digitalWrite(A3, (ledMatrix[lineNumber] & 0x0400) >> 3);
  digitalWrite(A2, (ledMatrix[lineNumber] & 0x0800) >> 4);

  delay(1);

  digitalWrite(2, LOW);
  digitalWrite(3, LOW);
  digitalWrite(4, LOW);
  digitalWrite(5, LOW);
  digitalWrite(6, LOW);
  digitalWrite(7, LOW);
  digitalWrite(8, LOW);
  digitalWrite(9, LOW);
  digitalWrite(A0, LOW);
  digitalWrite(A1, LOW);
  digitalWrite(A2, LOW);
  digitalWrite(A3, LOW);
}











